program Kheopful;
{$APPTYPE CONSOLE}

type
  IntArray = array of Integer;

var
  a,b,c: IntArray;
  n,p,x: Integer;
  s,t: Integer;

procedure Pyramid(q,l,m: Integer);
  var r,d,i,j,u,v: Integer;
begin
  if q <= p then begin
    for r := l+1 to n do begin
      d := a[r]; i := l; j := l-q+1;
      while (b[d] > l) and (i < m) do begin
        Inc(i); Inc(j); d := Abs (d - a[j]);
      end;
      if i = m then begin
        d := a[r]; i := l; j := l-q+1;
        while (b[d] > i) and (i < m) do begin
          Inc(i);
          v := a[i]; u := b[d]; c[i] := v;
          a[i] := d; a[u] := v;
          b[d] := i; b[v] := u;
          Inc(j); d := Abs (d - a[j]);
        end;
        if i = m then Pyramid(q+1,m,m+q+1);
        while i > l do begin
          v := a[i]; d := c[i]; u := b[d];
          a[i] := d; a[u] := v;
          b[d] := i; b[v] := u;
          Dec(i);
        end;
      end;
    end;
  end else begin
    Write(#13);
    for i := 1 to p do Write(a[(i*i-i+2) div 2],' ');
    Writeln;
    if s > 0 then Write(#13,t);
  end;
end;

function Integers(max: Integer): IntArray;
  var i: Integer;
begin
  SetLength(Result,max+1);
  for i := 0 to max do Result[i] := i;
end;

begin
  Writeln('Copyright(c) 2005 Damien Guichard');
  Write('How many levels? '); Readln(p);
  if p < 1 then Exit;
  Write('How many holes ? '); Readln(x);
  if x < 0 then Exit;
  n := p*(p+1) div 2 + x;
  Write('What seed value? '); Readln(s);
  if (s < 0) or (s > n) then Exit;
  a := Integers(n);
  b := Integers(n);
  c := Integers(n);
  if s = 0 then begin
    Pyramid(1,0,1); Exit;
  end;
  for t := s to n do begin
    Write(#13,t);
    a[1] := t; a[t] := 1;
    b[t] := 1; b[1] := t;
    Pyramid(2,1,3);
  end;
  Write(#13'  '#13);
end.
